﻿using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Globalization;
using System.Linq;
using System.IO;
using Microsoft.Win32;
using System.Security.Principal;
using System.Windows.Forms;
using System.Diagnostics;


namespace UnicodeToGB2312
{
    class Program
    {
        [STAThreadAttribute]
        static void Main(string[] args)
        {
            Console.ForegroundColor = ConsoleColor.Green;
            Console.Title= "欢迎访问小站：WWW.MYLUOLUO.COM";
            Console.WriteLine("欢迎访问小站：WWW.MYLUOLUO.COM");
            if (args.Count() >= 1)
            {
                for (int i = 0; i < args.Count(); i++)
                {
                    if (File.Exists(args[i]))
                    {
                        try
                        {
                            Console.ForegroundColor = ConsoleColor.Green;
                            StreamReader sr = new StreamReader(args[i], GetFileEncodeType(args[i]));
                            string file = sr.ReadToEnd();
                            sr.Close();
                            file = ToGB2312(file);
                            System.Windows.Forms.SaveFileDialog save = new System.Windows.Forms.SaveFileDialog();
                            save.Title = "[" + Path.GetFileName(args[i]) + "]的转换结果";
                            save.FileName = Path.GetRandomFileName().Split('.')[0] + Path.GetExtension(args[i]);
                            if (save.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                            {
                                try
                                {
                                    StreamWriter sw = new StreamWriter(save.FileName);
                                    sw.Write(file);
                                    sw.Close();
                                    Console.WriteLine(String.Format("文件：[{0}]转换成功！", Path.GetFileName(args[i])));
                                }
                                catch (Exception)
                                {
                                    Console.ForegroundColor = ConsoleColor.Red;
                                    Console.WriteLine("转换失败！");
                                }
                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.WriteLine("用户已取消保存！");
                            }
                        }
                        catch (Exception ex)
                        {
                            Console.ForegroundColor = ConsoleColor.Red;
                            Console.WriteLine(ex.Message);
                        }
                    }
                    else
                    {
                        Console.ForegroundColor = ConsoleColor.Red;
                        Console.WriteLine("文件：" + args[i] + "不存在！");
                        continue;
                    }
                }
            }
            else
            {
                if (!IsRunAsAdmin())
                {
                    Console.ForegroundColor = ConsoleColor.Red;
                    Console.WriteLine("任意键后将请求管理权限……");
                    Console.ReadKey();
                    // 使用管理员
                    ProcessStartInfo proc = new ProcessStartInfo();
                    proc.UseShellExecute = true;
                    proc.WorkingDirectory = Environment.CurrentDirectory;
                    proc.FileName = Application.ExecutablePath;
                    proc.Verb = "runas";

                    try
                    {
                        Process.Start(proc);
                    }
                    catch
                    {
                        Console.WriteLine("拒绝权限提升！");
                        Console.ReadKey();
                        // 拒绝提升权限则返回
                        return;
                    }
                    Environment.Exit(0);
                }
                string regKeyName = "UnicodeToGB2312";
                if (RegeditKeyExist(regKeyName))
                {
                    Console.WriteLine("请拖拽至程序，或者使用右键菜单进行转换，输入：d 将删除右键菜单。");
                    if (Console.ReadKey().Key == ConsoleKey.D)
                    {
                        Console.WriteLine();
                        try
                        {
                            DeleteContextMenu(regKeyName);
                            Console.WriteLine("删除成功！");
                        }
                        catch (Exception ex)
                        {
                            Console.ForegroundColor = ConsoleColor.Red;
                            Console.WriteLine("删除失败！\n" + ex.Message);
                        }
                    }
                }
                else
                {
                    
                    Console.WriteLine("请拖拽至程序，或者输入:y 将本程序添加至系统的右键菜单！");
                    if (Console.ReadKey().Key == ConsoleKey.Y)
                    {
                        Console.WriteLine();
                        if (!Directory.Exists(System.Environment.GetEnvironmentVariable("ProgramFiles") + "/UnicodeToGB2312/"))
                        {
                            Directory.CreateDirectory(System.Environment.GetEnvironmentVariable("ProgramFiles") + "/UnicodeToGB2312/");
                        }
                        if (File.Exists(System.Environment.GetEnvironmentVariable("ProgramFiles") + @"\UnicodeToGB2312\" + Path.GetFileName(System.Windows.Forms.Application.ExecutablePath)))
                            File.Delete(System.Environment.GetEnvironmentVariable("ProgramFiles") + @"\UnicodeToGB2312\" + Path.GetFileName(System.Windows.Forms.Application.ExecutablePath));
                        File.Copy(System.Windows.Forms.Application.ExecutablePath, System.Environment.GetEnvironmentVariable("ProgramFiles") + @"\UnicodeToGB2312\" + Path.GetFileName(System.Windows.Forms.Application.ExecutablePath));
                        AddFileContextMenuItem(regKeyName, System.Environment.GetEnvironmentVariable("ProgramFiles") + @"\UnicodeToGB2312\" + Path.GetFileName(System.Windows.Forms.Application.ExecutablePath) + " \"%1\"");
                    }
                } 
            }
            Console.WriteLine("任意键结束。。。");
            Console.ReadKey();
        }

        /// <summary>
        /// 将Unicode编码转换为汉字字符串
        /// </summary>
        /// <param name="str">Unicode编码字符串</param>
        /// <returns>汉字字符串</returns>
        public static string ToGB2312(string str)
        {
            string tempStr = str;
            MatchCollection mc = Regex.Matches(str, @"\\u([\w]{2})([\w]{2})", RegexOptions.Compiled | RegexOptions.IgnoreCase);
            byte[] bts = new byte[2];
            foreach (Match m in mc)
            {
                bts[0] = (byte)int.Parse(m.Groups[2].Value, NumberStyles.HexNumber);
                bts[1] = (byte)int.Parse(m.Groups[1].Value, NumberStyles.HexNumber);
                tempStr = tempStr.Replace(m.Value, Encoding.Unicode.GetString(bts));
            }
            return tempStr;
        }

        /// <summary>
        /// 判断文件编码
        /// </summary>
        /// <param name="filename"></param>
        /// <returns></returns>
        public static Encoding GetFileEncodeType(string filename)
        {
            System.IO.FileStream fs = new System.IO.FileStream(filename, System.IO.FileMode.Open, System.IO.FileAccess.Read);
            System.IO.BinaryReader br = new System.IO.BinaryReader(fs);
            Byte[] buffer = br.ReadBytes(2);
            if (buffer.Count() <= 0)
                throw new Exception("文件为空或未能识别！");

            if (buffer[0] >= 0xEF)
            {
                if (buffer[0] == 0xEF && buffer[1] == 0xBB)
                {
                    return Encoding.UTF8;
                }
                else if (buffer[0] == 0xFE && buffer[1] == 0xFF)
                {
                    return Encoding.BigEndianUnicode;
                }
                else if (buffer[0] == 0xFF && buffer[1] == 0xFE)
                {
                    return Encoding.Unicode;
                }
                else
                {
                    return Encoding.Default;
                }
            }
            else
            {
                return Encoding.Default;
            }
        }

        /// <summary>
        /// 注册右键菜单
        /// </summary>
        /// <param name="itemName">右键菜单名称</param>
        /// <param name="assoCreatedProgramFullPath">程序所在路径</param>
        private static void AddFileContextMenuItem(string itemName, string assoCreatedProgramFullPath)
        {
            try
            {
                
                //注册到所有文件
                RegistryKey shellKey = Registry.ClassesRoot.OpenSubKey(@"*\shell", true);
                //注册到所有目录
                // RegistryKey shell = Registry.ClassesRoot.OpenSubKey(@"directory\shell", true);
                //注册到文件夹
                //RegistryKey shell = Registry.ClassesRoot.OpenSubKey("directory", true).OpenSubKey("shell", true);
                if (shellKey == null)
                {
                    shellKey = Registry.ClassesRoot.CreateSubKey(@"*\shell");
                }
                RegistryKey rightCommondKey = shellKey.OpenSubKey(itemName);
                if (rightCommondKey == null)
                {
                    rightCommondKey = shellKey.CreateSubKey(itemName);
                }
                RegistryKey assoCreatedProgramKey = rightCommondKey.CreateSubKey("command");
                assoCreatedProgramKey.SetValue(string.Empty, assoCreatedProgramFullPath);
                assoCreatedProgramKey.Close();
                rightCommondKey.Close();
                shellKey.Close();
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// 删除菜单
        /// </summary>
        /// <param name="itemName"></param>
        private static void DeleteContextMenu(string itemName)
        {
            try
            {
                RegistryKey shellKey = Registry.ClassesRoot.OpenSubKey(@"*\shell", true);
                RegistryKey rightCommondKey = shellKey.OpenSubKey(itemName, true);
                if (rightCommondKey != null)
                {
                    rightCommondKey.DeleteSubKeyTree("");
                }
            }
            catch (Exception ex)
            {

                throw ex;
            }
        }

        /// <summary>  
        /// 根据键的名称，验证该键是否存在  
        /// </summary>  
        /// <param name="keyName">键的名称</param>  
        /// <returns></returns>  
        public static bool RegeditKeyExist(string keyName)
        {
            RegistryKey hkml = Registry.ClassesRoot;
            RegistryKey software = hkml.OpenSubKey(@"*\shell\" + keyName);


            //如果注册表中不存在该项则返回  
            if (software == null)
                return false;
            else
                return true;
        }

        /// <summary>
        /// The function checks whether the current process is run as administrator.
        /// In other words, it dictates whether the primary access token of the
        /// process belongs to user account that is a member of the local
        /// Administrators group and it is elevated.
        /// 判断当前账户是否为管理员账户
        /// </summary>
        /// <returns>
        /// Returns true if the primary access token of the process belongs to user
        /// account that is a member of the local Administrators group and it is
        /// elevated. Returns false if the token does not.
        /// </returns>
        internal static bool IsRunAsAdmin()
        {
            WindowsIdentity id = WindowsIdentity.GetCurrent();
            WindowsPrincipal principal = new WindowsPrincipal(id);
            return principal.IsInRole(WindowsBuiltInRole.Administrator);
        }
    }
}
